Package: CompetingRisk
Type: Package
Title: The Semi-Parametric Cumulative Incidence Function
Version: 1.0
Date: 2017-02-25
Author: Jiayi Hou,
        Ronghui Xu
Maintainer: Jiayi Hou <jhou12@icloud.com>
Description: Computing the point estimator and pointwise confidence interval of the cumulative incidence function from the cause-specific hazards model.
Depends: survival, MASS, wesanderson, reshape2, stats, graphics,
        methods, Matrix
License: GPL-3
RoxygenNote: 6.0.1
NeedsCompilation: no
Packaged: 2017-03-02 03:49:43 UTC; jiayihou
Repository: CRAN
Date/Publication: 2017-03-02 08:09:10

Lambda_k <-
function(est, x, y, group, data, newdata, group.in.train){
                     y0 <- unique(y[y[,2]==1,1])
                     y0 <- y0[order(y0)]

                     if (is.null(group)){
                         if (is.null(newdata)){
                             x.new <- model.matrix(est$formula, data = data)
                             x.new <- x.new[,-1]

                             } else if (is.null(newdata)==F){
                               if(ncol(data) == ncol(newdata)){
                                  x.new <- model.matrix(est$formula, data = newdata)
                                  x.new <- x.new[,-1]
                               } else {
                                  x.new <- newdata[, names(est$coefficients)]
                             }
                         }

                         if (is.vector(x.new)){
                             z0 <- x.new
                             } else {
                             z0 <- apply(x.new, 2, mean)
                           }

                           temp <- Baseline_Lambda_k(est, x, y)
                           Lambda0k <- temp$Lambda0k
                           h0 <- temp$h0
                           beta <- est$coefficients
                           Lambda_k <- Lambda0k* exp(z0 %*% beta)
                           h_k <- h0*exp(z0 %*% beta)
                           Hazard.table <- data.frame(events.time=y0, Lambda_k, h_k)
                     }

                     if (is.null(group)==F){

                         if (is.null(newdata)){
                             x.new <- data
                         } else {
                             x.new <- newdata
                         }

                           n.group <- nlevels(factor(x.new[, group]))
                           temp <- Baseline_Lambda_k(est, x,y)
                           Lambda0k <- temp$Lambda0k
                           h0 <- temp$h0
                           beta <- est$coefficients

                           if(group.in.train==F){
                              xlist <- split(data.frame(x.new), f=x.new[, group])
                              xlist <- lapply(xlist, function(x) x[,names(beta)])
                              beta.z0 <- lapply(xlist, function(x) exp(apply(x, 2, mean) %*% beta))
                              Lambda_k <- lapply(beta.z0, function(x) Lambda0k*x)
                              Lambda_k <- Reduce("cbind", Lambda_k)
                              colnames(Lambda_k) <- paste("Lambda_k", 1:ncol(Lambda_k), sep="")
                              Lambda_k <- data.frame(id=1:nrow(Lambda_k), Lambda_k)
                              Lambda_k <- melt(Lambda_k, id.vars="id")[,"value"]

                              h_k <- lapply(beta.z0, function(x) h0*x)
                              h_k <- Reduce("cbind", h_k)
                              colnames(h_k) <- paste("h_k", 1:ncol(h_k), sep="")
                              h_k <- data.frame(id=1:nrow(h_k), h_k)
                              h_k <- melt(h_k, id.vars="id")[,"value"]
                           }

                           if (group.in.train==T){
                               beta <- c(beta, rep(0, (nlevels(data[,group])-1)))
                               group.names <- paste(group, levels(newdata[,group]), sep="")
                               names(beta)[length(beta)] <- group.names[!group.names %in% names(beta)]
                               xlist <- split(data.frame(x.new), f=x.new[, group])

                           change.name <- function(x){
                                          index <- which(colnames(x)==group)
                                          colnames(x)[index] <- paste(group, x[1,group], sep="")
                                          x[,index] <- rep(1, nrow(x))
                                          return(x)
                           }

                           beta.group <- z0 <- list()
                           for (jj in 1:length(xlist)){
                                xlist[[jj]] <- change.name(xlist[[jj]])
                                beta.group[[jj]] <- beta[names(beta) %in% names(xlist[[jj]])]
                                z0[[jj]] <- apply(xlist[[jj]][colnames(xlist[[jj]]) %in% names(beta.group[[jj]])], 2, mean)
                                z0[[jj]] <- z0[[jj]][names(beta.group[[jj]])]
                           }

                           Lambda_k <- sapply(exp(mapply("%*%", z0, beta.group)),  function(x) Lambda0k*x)
                           colnames(Lambda_k) <- paste("Lambda_k", 1:ncol(Lambda_k), sep="")
                           Lambda_k <- data.frame(id=1:nrow(Lambda_k), Lambda_k)
                           Lambda_k <- melt(Lambda_k, id.vars="id")[,"value"]

                           h_k <- sapply(exp(mapply("%*%", z0, beta.group)),  function(x) h0*x)
                           colnames(h_k) <- paste("h_k", 1:ncol(h_k), sep="")
                           h_k <- data.frame(id=1:nrow(h_k), h_k)
                           h_k <- melt(h_k, id.vars="id")[,"value"]
                           }

                           Hazard.table <- data.frame(events.time = rep(y0, times = n.group),
                                                      Lambda_k = Lambda_k, h_k = h_k,
                                                      group = rep(levels(factor(x.new[, group])),
                                                                  each = length(y0)))
                           Hazard.table$group <- factor(Hazard.table$group, levels=levels(x.new[, group]))
                       }
                     return(Hazard.table)
}

RawVar.CIF <-
function(formulas, CIFest, data, newdata, group, event, save, group.in.train){

              if (is.null(group)==F){
                 CIF.var <- list()
                 for (kk in 1:length(formulas)){
                      if (is.null(newdata)){
                          x.new <- data
                          } else {
                          x.new <- newdata
                      }

                      est <- coxph(formulas[[kk]], data = data)
                      xlist <- split(data.frame(x.new), f=x.new[, group])
                      xlist <- lapply(xlist, function(x) x[colnames(x)!=group])
                      beta <- est$coefficients
                      beta <- beta[names(beta) %in% names(xlist[[1]])]
                      z0 <- lapply(xlist, function(x) apply(x[, names(beta)], 2, mean))
                      CIF.var.group <- list()

                    for (jj in 1:length(xlist)){
                         #--- line 1 ---#
                         S <- CIFest[[jj]]$Survival
                         Fk.z0 <- CIFest[[jj]][, grep(paste("CIF", kk, sep=""), colnames(CIFest[[jj]]))]
                         Fk.z0.xi <- CIFest[[jj]][, grep(paste("CIF.xi", kk, sep=""), colnames(CIFest[[jj]]))]
                         delta.kk <- CIFest[[jj]][, grep(paste("delta",kk, sep=""), colnames(CIFest[[jj]]))]
                         mf <- model.frame(formula = formulas[[kk]], data = data)
                         est <- coxph(formulas[[kk]], data = data)
                         x <- model.matrix(formulas[[kk]], data = data)
                         x <- x[, -1]
                         y <- model.response(mf)
                         n <- nrow(data)
                         S01 <- Compute_S01(est=est, x=x, y=y, kk=kk, event=event,
                                            group=group, save=save, group.in.train=group.in.train)
                         S0 <- S01$S0
                         item1 <- (S - (Fk.z0 - Fk.z0.xi))^2 * delta.kk
                         item1 <- item1 * as.numeric(exp(2*beta %*% z0[[jj]]) / S0^2)
                         item1 <- suppressWarnings(item1 *delta.kk)
                         line1 <- cumsum(item1) /n

                          #--- line2 ----#
                         line2 <- NULL
                         K.cause <- length(formulas)
                         LL <- setdiff(1:K.cause, kk)

                         for (ll in LL){
                             Fk.z0 <- CIFest[[jj]][, grep(paste("CIF", kk, sep=""), colnames(CIFest[[jj]]))]
                             Fk.z0.xi <- CIFest[[jj]][, grep(paste("CIF.xi", kk, sep=""), colnames(CIFest[[jj]]))]
                             delta.ll <- CIFest[[jj]][, grep(paste("delta",ll, sep=""), colnames(CIFest[[jj]]))]
                             mf <- model.frame(formula = formulas[[ll]], data = data)
                             x <- model.matrix(formulas[[ll]], data = data)
                             x <- x[, -1]
                             y <- model.response(mf)
                             est <- coxph(formulas[[ll]], data = data)
                             S01 <- Compute_S01(est=est, x=x, y=y, kk=kk, event=event,
                                                group=group, save=save, group.in.train=group.in.train)
                             S0 <- S01$S0
                             item1 <- cumsum(suppressWarnings((Fk.z0 - Fk.z0.xi)^2 * exp(2*beta %*% z0[[jj]])/S0^2 * delta.ll))/n
                             line2 <- cbind(line2, item1)
                          }
                         line2 <- apply(line2, 1, sum)

                         #--- line 3-----#
                         mf <- model.frame(formula = formulas[[kk]], data = data)
                         x <- model.matrix(formulas[[kk]], data = data)
                         x <- x[, -1]
                         y <- model.response(mf)
                         est <- coxph(formulas[[kk]], data = data)
                         Varphi_k <- Varphi_par(est=est, x=x, y=y, kk=kk, CIFest=CIFest,
                                                data=data, newdata=newdata, group=group, event=event,
                                                save=save,group.in.train = group.in.train)[[jj]]
                         Psi_kk <- Psi_par(formulas=formulas, kk=kk, ll=kk, CIFest=CIFest,
                                           data=data, newdata=newdata, group=group, event=event,
                                           save=save,group.in.train=group.in.train)[[jj]]
                         diff <- Varphi_k - Psi_kk
                         Omega <- Compute_Omega(est=est, x=x, y=y,kk=kk, event=event, group=group,
                                                save=save, group.in.train=group.in.train)
                         omega <- Reduce("+", Omega)/n
                         inv.omega.k <- Matrix(ginv(as.matrix(omega)))
                         line3 <- apply(diff, 2, function(x) as.numeric(t(x) %*% inv.omega.k %*% x))
                         line3 <- suppressWarnings(line3 *delta.kk)
                         rm(Psi_kk, Varphi_k, Omega, diff, inv.omega.k)

                         #---- line 4----#
                         line4 <- rep(0, length(line3))
                         K.cause <- length(formulas)
                         LL <- setdiff(1:K.cause, kk)

                         for (ll in LL){
                             mf <- model.frame(formula = formulas[[ll]], data = data)
                             x <- model.matrix(formulas[[ll]], data = data)
                             x <- x[, -1]
                             y <- model.response(mf)
                             est <- coxph(formulas[[ll]], data = data)
                             delta.ll <- CIFest[[jj]][, grep(paste("delta",ll, sep=""), colnames(CIFest[[jj]]))]
                             Omega <- Compute_Omega(est=est, x=x, y=y, kk=ll, event=event,
                                                    group=group, save=save, group.in.train=group.in.train)
                             omega <- Reduce("+", Omega)/n
                             inv.omega.l <- Matrix(ginv(as.matrix(omega)))
                             Psi_kl <- Psi_par(formulas=formulas, kk=kk, ll = ll, CIFest=CIFest,
                                               data=data, newdata=newdata, group=group,
                                               event=event,save=save, group.in.train=group.in.train)[[jj]]
                             temp <- apply(Psi_kl, 2, function(x) as.numeric(t(x) %*% inv.omega.l %*% x))
                             temp <- suppressWarnings(temp * delta.ll)
                             line4 <- line4 + temp
                             rm(Psi_kl, Omega, inv.omega.l)
                         }
                        CIF.var.group[[jj]] <- line1 + line2 + line3 + line4
                      }
                    CIF.var[[kk]] <- CIF.var.group
                  }
               }

#==========if group = NULL=====================================================#
              if (is.null(group)){


              CIF.var <- list()
              for (kk in 1:length(formulas)){
                  est <- coxph(formulas[[kk]], data = data)

                  if (is.null(newdata)){
                     x.new <- model.matrix(est$formula, data = data)
                     x.new <- x.new[,-1]
                     } else if (is.null(newdata)==F){
                               if(ncol(data) == ncol(newdata)){
                                  x.new <- model.matrix(est$formula, data = newdata)
                                  x.new <- x.new[,-1]
                                } else {
                                  x.new <- newdata[, names(est$coefficients)]
                              }
                          }

                      if (is.vector(x.new)){
                         z0 <- x.new
                         } else {
                         z0 <- apply(x.new, 2, mean)
                      }

              #--- line 1 ---#
              S <- CIFest$Survival
              Fk.z0 <- CIFest[, grep(paste("CIF", kk, sep=""), colnames(CIFest))]
              Fk.z0.xi <- CIFest[, grep(paste("CIF.xi", kk, sep=""), colnames(CIFest))]
              delta.kk <- CIFest[, grep(paste("delta",kk, sep=""), colnames(CIFest))]
              n <- nrow(data)
              est <- coxph(formulas[[kk]], data = data)
              beta <- est$coefficients
              mf <- model.frame(formula = formulas[[kk]], data = data)
              x <- model.matrix(formulas[[kk]], data = data)
              x <- x[, -1]
              y <- model.response(mf)
              S01 <- Compute_S01(est, x, y, kk, event, group, save)
              S0 <- S01$S0

              item1 <- (S - (Fk.z0 - Fk.z0.xi))^2 * delta.kk
              item1 <- item1 * as.numeric(exp(2*beta %*% z0) / S0^2)
              item1 <- suppressWarnings(item1 *delta.kk)
              line1 <- cumsum(item1) /n

              #--- line2 ----#
              line2 <- NULL
              K.cause <- length(formulas)
              LL <- setdiff(1:K.cause, kk)
              n <- nrow(data)

              for (ll in LL){
                  Fk.z0 <- CIFest[, grep(paste("CIF", kk, sep=""), colnames(CIFest))]
                  Fk.z0.xi <- CIFest[, grep(paste("CIF.xi", kk, sep=""), colnames(CIFest))]
                  delta.ll <- CIFest[, grep(paste("delta",ll, sep=""), colnames(CIFest))]
                  mf <- model.frame(formula = formulas[[ll]], data = data)
                  x <- model.matrix(formulas[[ll]], data = data)
                  x <- x[, -1]
                  y <- model.response(mf)
                  est <- coxph(formulas[[ll]], data = data)
                  beta <- est$coefficients
                  beta <- beta[names(beta) %in% names(z0)] #need double check #
                  z0 <- z0[names(beta)]
                  S01 <- Compute_S01(est, x, y, ll, event, group,save)
                  S0 <- S01$S0
                  item1 <- cumsum(suppressWarnings((Fk.z0 - Fk.z0.xi)^2*exp(2*beta %*% z0)/S0^2*delta.ll))/n
                  line2 <- cbind(line2, item1)
              }
              line2 <- apply(line2, 1, sum)


              #--- line 3-----#
              mf <- model.frame(formula = formulas[[kk]], data = data)
              x <- model.matrix(formulas[[kk]], data = data)
              x <- x[, -1]
              y <- model.response(mf)
              est <- coxph(formulas[[kk]], data = data)
              delta.kk <- CIFest[, grep(paste("delta",kk, sep=""), colnames(CIFest))]
              Varphi_k <- Varphi_par(est, x, y, kk, CIFest, data, newdata, group, event,save)
              Psi_kk <- Psi_par(formulas, kk, ll = kk, CIFest, data, newdata, group,event,save)
              diff <- Varphi_k - Psi_kk
              Omega <- Compute_Omega(est, x, y,kk, event, group,save)



              omega <- Reduce("+", Omega)/n
              inv.omega.k <- Matrix(ginv(as.matrix(omega)))
              line3 <- apply(diff, 2, function(x) as.numeric(t(x) %*% inv.omega.k %*% x))
              line3 <- suppressWarnings(line3 *delta.kk)
              rm(Psi_kk, Varphi_k, Omega, diff, inv.omega.k)


              #--- line4 -----#
              line4 <- rep(0,  nrow(CIFest))
              K.cause <- length(formulas)
              LL <- setdiff(1:K.cause, kk)
              n <- nrow(data)

              for (ll in LL){
                   mf <- model.frame(formula = formulas[[ll]], data = data)
                   x <- model.matrix(formulas[[ll]], data = data)
                   x <- x[, -1]
                   y <- model.response(mf)
                   est <- coxph(formulas[[ll]], data = data)
                   delta.ll <- CIFest[, grep(paste("delta",ll, sep=""), colnames(CIFest))]
                   Omega <- Compute_Omega(est, x, y, ll, event, group, save)
                   omega <- Reduce("+", Omega)/n
                   inv.omega.l <- Matrix(ginv(as.matrix(omega)))
                   Psi_kl <- Psi_par(formulas, kk, ll = ll, CIFest, data, newdata, group, event,save)
                   delta.ll <- CIFest[, grep(paste("delta", ll, sep=""), colnames(CIFest))]
                   temp <- apply(Psi_kl, 2, function(x) as.numeric(t(x) %*% inv.omega.l %*% x))
                   temp <- suppressWarnings(temp * delta.ll)
                   line4 <- line4 + temp
                   rm(Psi_kl, Omega, inv.omega.l, temp)
              }

              CIF.var[[kk]] <- line1 + line2 + line3 + line4
           }
        }
        return(CIF.var)
}

Impute.Lambda <-
function(x){
                 Lambda <- data.frame(x[, colnames(x)[grep("Lambda", colnames(x))]])
                 for (jj in 1:ncol(Lambda)){
                   for (ii in 2:nrow(Lambda)){
                      if (is.na(Lambda[ii,jj])){
                         Lambda[ii,jj] <- Lambda[ii-1,jj]
                     }
                   }
                 }
                 x[, colnames(Lambda)] <- Lambda
                 return(x)
}

Compute_Omega <-
function(est, x, y, kk, event, group, save, group.in.train){

                 rda.filename=paste("Omega", kk, ".rda", sep="")
                    if (file.exists(rda.filename)) {
                       print(paste("loading Omega",rda.filename,sep=" "))
                       load(rda.filename)
                       print("finished loading")
                       return(Omega)
                 }

                 S01 <- Compute_S01(est=est, x=x, y=y, kk=kk, event=event,
                                    group=group, save=save, group.in.train=group.in.train)
                 S0 <- as.list(S01$S0)
                 S1 <- S01$S1
                 Zj <- S01$Zj
                 nj <- S01$nj
                 n <- nrow(x)
                 exp.betaz <- S01$exp.betaz

                 new.data <- cbind(time = y[,1], event = event, x)
                 new.data <- new.data[order(est$y[,1]),]
                 table <- data.frame(table(new.data[new.data[,"event"]!=0, "time"]))
                 colnames(table) <- c("events.time", "freq")
                 y0 <- as.numeric(as.character(table[,"events.time"])) - 1e-7
                 h0 <- NULL
                 beta <- est$coefficients

                 if ((is.null(group)==F) && (group.in.train==T)){
                     beta <- beta[-grep(group, names(beta))]
                 }

                 #---Compute S2 using Matrix package--- #
                 b= as.matrix(Zj[[1]])
                 zz <- list()
                 for (ii in 1:n){
                     zz[[ii]]<- Matrix((b[ii,]) %*% t(b[ii,]))
                 }
                 expbz.zz <- mapply(function(a, b) a*b, a=as.list(exp.betaz[[1]]), b=zz)
                 S2 <- list()
                 new.data <- data.frame(index = 1:n, new.data)

                 for (ii in 1:length(nj)){
                      index <- new.data[new.data[, "time"] >=y0[ii], "index"]
                      S2[[ii]] <- Reduce("+", expbz.zz[index])/nj[ii]
                 }
                 S2_div_S0 <- mapply(function(a,b) {a/b}, S2, S0)
                 Zbar <- mapply(function(a,b) {a/b}, S1, S0)
                 Zbar2 <- list()

                 for (ii in 1:length(nj)){
                     Zbar2[[ii]]<- Matrix(Zbar[,ii] %*% t(Zbar[,ii]))
                 }

                 Omega <- mapply(function(a,b) a-b, S2_div_S0, Zbar2)
                 Omega <- lapply(Omega, as.matrix)
                 rm(S2_div_S0, S01, Zbar, Zbar2)

                 if(save==T){
                    save(Omega, file=paste("Omega", kk, ".rda", sep=""))
                 }
                 return(Omega)
}

Baseline_Lambda_k <-
function(est, x, y){
                     new.data <- cbind(time = y[,1], status = y[,2], x)
                     new.data <- new.data[order(est$y[,1]),]
                     table <- data.frame(table(new.data[new.data[,"status"]==1, "time"]))
                     colnames(table) <- c("events.time", "freq")

                     y0 <- unique(y[y[,2]==1,1])
                     y0 <- y0[order(y0)]
                     d <- table[,"freq"]
                     h0 <- NULL
                     beta <- est$coefficients

                     for (ii in 1:nrow(table)){
                         zj <- subset(new.data, new.data[,"time"] >= y0[ii])
                         h0[ii] <- d[ii] /sum(exp(as.matrix(zj[,colnames(x)]) %*% beta))
                         new.data <- zj
                     }
                     Lambda0k <- cumsum(h0)
                     temp <- data.frame(events.time=y0, h0, Lambda0k)
                     return(temp)
}

#' @method plot CIF
plot.CIF <-
function(x, type=NULL,...){

            colors <- wes_palette(n = length(x), name ="Rushmore")

          # plot group=NULL with confidence interval #
          if(is.null(type)){
            if (ncol(x[[1]]$Estimate)==6){
                par(mfrow=c(1,length(x)))
                par(mar=c(12,4,12,4))

                for (kk in 1:length(x)){
                    temp <- subset(x[[kk]]$Estimate, x[[kk]]$Estimate$delta==1)
                    plot(temp$Events.Time, temp$Cumulative.Incidence, lwd=2,
                         col=colors[kk], type="l",xlab= "Time",
                         ylab= "Cumulative Incidence", ylim = c(0, 1))
                    lines(temp$Events.Time,temp$Upper.Bound, col=colors[kk], lwd=1, lty=2)
                    lines(temp$Events.Time,temp$Lower.Bound, col=colors[kk], lwd=1, lty=2)
                }
            }
           # plot group=NULL without confidence interval #
            if (ncol(x[[1]]$Estimate)==4){
                par(mfrow=c(1,length(x)))
                par(mar=c(12,4,12,4))

                for (kk in 1:length(x)){
                    temp <- subset(x[[kk]]$Estimate, x[[kk]]$Estimate$delta==1)
                    plot(temp$Events.Time, temp$Cumulative.Incidence, lwd=2,
                         col=colors[kk], type="l", xlab= "Time",
                         ylab= "Cumulative Incidence", ylim = c(0, 1))
                }
              }
          }

          # plot group without confidence intervel #
          if(is.null(type)==F){
             if(ncol(x[[1]][[1]]$Estimate)==4){
               n.group <- length(x[[1]])
               n.causes <- length(x)
               par(mfrow=c(n.group, n.causes)) # this is incorrect # #No.group * No.causes #
               par(mar=c(2,4,2,4))

               for(jj in 1:length(x[[1]])){
                  for(kk in 1:length(x)){
                       plot(x[[kk]][[1]]$Estimate$Events.Time, type="n",xlab= "Time",
                            ylab= "Cumulative Incidence", ylim = c(0, 0.5))
                       temp <- subset(x[[kk]][[jj]]$Estimate, x[[kk]][[jj]]$Estimate$delta==1)
                       lines(temp$Events.Time, temp$Cumulative.Incidence, lwd=2, col=colors[kk])
                   }
               }
             }

            # plot group with confidence interval #
             if(ncol(x[[1]][[1]]$Estimate)==6){
               n.group <- length(x[[1]])
               n.causes <- length(x)
               par(mfrow=c(n.group, n.causes))
               par(mar=c(2,4,2,4))

               for(jj in 1:length(x[[1]])){
                   for(kk in 1:length(x)){
                       plot(x[[kk]][[1]]$Estimate$Events.Time, type="n",xlab= "Time",
                            ylab= "Cumulative Incidence", ylim = c(0, 1))
                       temp <- subset(x[[kk]][[jj]]$Estimate, x[[kk]][[jj]]$Estimate$delta==1)
                       lines(temp$Events.Time,temp$Cumulative.Incidence, lwd=2, col=colors[kk])
                       lines(temp$Events.Time,temp$Upper.Bound, col=colors[kk], lwd=1, lty=2)
                       lines(temp$Events.Time,temp$Lower.Bound, col=colors[kk], lwd=1, lty=2)
                   }
               }
             }
          }
}

Psi_par <-
function(formulas, kk, ll, CIFest, data, newdata, group, event, save, group.in.train){

                     if (is.null(group)){
                         est <- coxph(formulas[[kk]], data = data)
                         if (is.null(newdata)){
                              x.new <- model.matrix(est$formula, data = data)
                              x.new <- x.new[,-1]
                              } else if (is.null(newdata)==F){
                                if(ncol(data) == ncol(newdata)){
                                   x.new <- model.matrix(est$formula, data = newdata)
                                   x.new <- x.new[,-1]
                                } else {
                                   x.new <- newdata[, names(est$coefficients)]
                              }
                          }

                        if (is.vector(x.new)){
                             z0 <- x.new
                             } else {
                             z0 <- apply(x.new, 2, mean)
                             }

                      Fk.z0 <- CIFest[, grep(paste("CIF", kk, sep=""), colnames(CIFest))]
                      Fk.z0.xi <- CIFest[, grep(paste("CIF.xi", kk, sep=""), colnames(CIFest))]
                      mf <- model.frame(formula = formulas[[ll]], data = data)
                      x <- model.matrix(formulas[[ll]], data = data)
                      x <- x[, -1]
                      y <- model.response(mf)
                      est <- coxph(formulas[[ll]], data = data)
                      beta <- est$coefficients
                      z0 <- z0[names(beta)]
                      z0[is.na(z0)] <- 0

                      S01 <- Compute_S01(est=est, x=x, y=y, kk=ll, event=event, group=NULL,
                                         save=save, group.in.train=group.in.train)
                      n <- nrow(x)
                      S0 <- S01$S0
                      S1 <- S01$S1
                      Zbar <- mapply(function(a,b) {a/b}, S1, S0)
                      item1 <- Matrix(matrix(0, ncol = ncol(Zbar), nrow=length(z0)))

                         for (ii in 1:ncol(Zbar)){
                              item1[, ii] <- (Fk.z0 - Fk.z0.xi)[ii] * (z0 - t(Zbar[,ii])) *
                                              as.numeric(exp(beta %*% z0) / S0[ii])
                         }
                    psi.kl <- Matrix(t(apply(item1, 1, function(x) cumsum(x)/n)))
                  }

                  if (is.null(group)==F){
                          mf <- model.frame(formula = formulas[[ll]], data = data)
                          x <- model.matrix(formulas[[ll]], data = data)
                          x <- x[, -1]
                          y <- model.response(mf)
                          est <- coxph(formulas[[ll]], data = data)

                          if (is.null(newdata)){
                             x.new <- data
                             } else {
                             x.new <- newdata
                             }
                          xlist <- split(data.frame(x.new), f=x.new[, group])
                          xlist <- lapply(xlist, function(x) x[colnames(x)!=group])
                          beta <- est$coefficients
                          beta <- beta[names(beta) %in% names(xlist[[1]])]
                          z0 <- lapply(xlist, function(x) apply(x[, names(beta)], 2, mean))

                          psi.kl <- list()
                          for (jj in 1:length(z0)){
                              Fk.z0 <- CIFest[[jj]][, grep(paste("CIF", kk, sep=""), colnames(CIFest[[jj]]))]
                              Fk.z0.xi <- CIFest[[jj]][, grep(paste("CIF.xi", kk, sep=""), colnames(CIFest[[jj]]))]
                              S01 <- Compute_S01(est=est, x=x, y=y, kk=ll, event=event, group=group,
                                             save=save, group.in.train=group.in.train)
                              n <- nrow(x)
                              S0 <- S01$S0
                              S1 <- S01$S1
                              Zbar <- mapply(function(a,b) {a/b}, S1, S0)

                              item1 <- Matrix(matrix(0, ncol = ncol(Zbar), nrow=length(z0[[1]])))

                              for (ii in 1:ncol(Zbar)){
                                    item1[, ii] <- (Fk.z0 - Fk.z0.xi)[ii] * (z0[[jj]] - t(Zbar[,ii])) *
                                                    as.numeric(exp(beta %*% z0[[jj]]) / S0[ii])
                               }
                              psi.kl[[jj]] <- Matrix(t(apply(item1, 1, function(x) cumsum(x)/n)))
                          }
                   }
                  rm(S0, S1, S01, Zbar)
                  return(psi.kl)
}

Varphi_par <-
function(est, x, y, kk, CIFest, data, newdata, group, event, save, group.in.train){

                      S01 <- Compute_S01(est=est, x=x, y=y, kk=kk, event=event,
                                         group=group, save=save, group.in.train=group.in.train)
                      beta <- est$coefficients
                      n <- nrow(x)
                      S0 <- S01$S0
                      S1 <- S01$S1
                      Zbar <- mapply(function(a,b) {a/b}, S1, S0)

                      if (is.null(group)){
                          if (is.null(newdata)){
                              x.new <- model.matrix(est$formula, data = data)
                              x.new <- x.new[,-1]
                              } else if (is.null(newdata)==F){
                                if(ncol(data) == ncol(newdata)){
                                   x.new <- model.matrix(est$formula, data = newdata)
                                   x.new <- x.new[,-1]
                                } else {
                                   x.new <- newdata[, names(est$coefficients)]
                              }
                          }

                         if (is.vector(x.new)){
                             z0 <- x.new
                             } else {
                             z0 <- apply(x.new, 2, mean)
                           }

                      item1 <- Matrix(matrix(0, ncol = ncol(Zbar), nrow=length(est$coefficients)))
                      for (ii in 1:ncol(Zbar)){
                          item1[, ii] <- CIFest$Survival[ii]*(z0 - t(Zbar[,ii])) *
                                         as.numeric(exp(beta %*% z0) / S0[ii])
                      }
                      varphi.k <- Matrix(t(apply(item1, 1, function(x) cumsum(x)/n)))
                      }


                      if (is.null(group)==F){
                          if (is.null(newdata)){
                             x.new <- data
                             } else {
                             x.new <- newdata
                             }
                          xlist <- split(data.frame(x.new), f=x.new[, group])
                          xlist <- lapply(xlist, function(x) x[colnames(x)!=group])
                          beta <- est$coefficients
                          beta <- beta[names(beta) %in% names(xlist[[1]])]
                          z0 <- lapply(xlist, function(x) apply(x[, names(beta)], 2, mean))

                          varphi.k <- list()
                          for (jj in 1:length(z0)){
                              item1 <- Matrix(matrix(0, ncol = ncol(Zbar), nrow=length(z0[[1]])))
                              Survival.z0 <- CIFest[[jj]]$Survival

                              for (ii in 1:ncol(Zbar)){
                                  item1[, ii] <- Survival.z0[ii]*(z0[[jj]] - t(Zbar[,ii])) *
                                                 as.numeric(exp(beta %*% z0[[jj]]) / S0[ii])
                              }
                           varphi.k[[jj]] <- Matrix(t(apply(item1, 1, function(x) cumsum(x)/n)))
                          }
                      }
                      rm(S0, S1, S01, Zbar)
                      return(varphi.k)
            }

Compute_S01 <-
function(est, x, y, kk, event, group, save, group.in.train){

                 rda.filename=paste("S01_Event_", kk, ".rda", sep="")
                 if (file.exists(rda.filename)) {
                     print(paste("loading stored S0 and S1",rda.filename,sep=" "))
                     load(rda.filename)
                     print("finished loading")
                     return(S01)
                 }

                     new.data <- cbind(time = y[,1], event = event, x)
                     new.data <- new.data[order(est$y[,1]),]
                     table <- data.frame(table(new.data[new.data[,"event"]!=0, "time"]))
                     colnames(table) <- c("events.time", "freq")
                     y0 <- as.numeric(as.character(table[,"events.time"]))
                     y0 <- as.numeric(as.character(table[,"events.time"])) - 1e-7
                     h0 <- NULL
                     beta <- est$coefficients

                     if ((is.null(group)==F) && (group.in.train==T)){
                        beta <- beta[-grep(group, names(beta))]
                     }

                     #---- S0 ------ this is problematic #
                     exp.betaz <- Zj <- list()
                     nj <- NULL
                     for (ii in 1:nrow(table)){
                         zj <- subset(new.data, new.data[,"time"] >= y0[ii])
                         exp.betaz[[ii]] <- exp(as.matrix(zj[, names(beta)]) %*% as.vector(beta))
                         Zj[[ii]] <- zj[, names(beta)]
                         nj[ii] <- nrow(zj)
                     }
                     S0 <- unlist(lapply(exp.betaz, function(x) sum(x)))
                     S0 <- S0/nj

                     #-----S1----#
                     S1 <- mapply(function(a,b) t(as.matrix(a)) %*% as.matrix(b), exp.betaz, Zj)
                     S1 <- apply(S1, 1, function(x) x)
                     S1 <- split(S1, row(S1))
                     S1 <- mapply(function(a,b) a/b, S1, as.list(nj))
                     S1 <- split(S1, col(S1))

                S01 <- list(Zj=Zj, exp.betaz=exp.betaz, nj=nj, S0=S0, S1=S1)
                if(save==T){
                   save(S01, file=paste("S01_Event_", kk, ".rda", sep=""))
                }
                return(S01)
}

Impute.h <-
function(x){
            h <- data.frame(x[, colnames(x)[grep("h", colnames(x))]])
            delta <- apply(h, 2, function(x) ifelse(is.na(x), 0, 1))
            h[is.na(h)] <- 0
            x[, colnames(h)] <- h
            return(data.frame(x, delta))
}

CIF_k <-
function(Hazard.table, group){
         K.cause <- length(Hazard.table)

         if (is.null(group)){
            Hazard.table <- Reduce(function(x, y) merge(x, y, by="events.time", all=TRUE), Hazard.table)
            Hazard.table <- Impute.Lambda(Hazard.table)
            Hazard.table <- Impute.h(Hazard.table)
            colnames(Hazard.table) <- c("events.time", paste(rep(c("Lambda","h"), times = K.cause),
                                                             rep(1:K.cause, each = 2), sep=""),
                                                       paste("delta", 1:K.cause, sep=""))
            Survival <- exp(- apply(Hazard.table[, grep("Lambda", colnames(Hazard.table))], 1, sum))
            Survival <- ifelse(is.na(Survival), 1, Survival)
            h <- Hazard.table[, grep("h", colnames(Hazard.table))]
            delta <- Hazard.table[, grep("delta", colnames(Hazard.table))]


            CIF <- apply(Survival*h, 2, cumsum)
            CIF.xi <- Survival*h
            CIF.table <- data.frame(events.time = Hazard.table$events.time, Survival, CIF, CIF.xi, delta)
            colnames(CIF.table) <- c("events.time", "Survival", paste("CIF", 1:K.cause, sep=""),
                                     paste("CIF.xi", 1:K.cause, sep=""), paste("delta", 1:K.cause, sep=""))
         }

        if (is.null(group)==F){
            if(class(Hazard.table) == "list") {
               n.group <- nlevels(factor(Hazard.table[[1]][, "group"]))
            }
            if(class(Hazard.table) == "data.frame"){
               n.group <- nlevels(factor(Hazard.table[, "group"]))
            }
             Hazard.by.group <- lapply(Hazard.table, function(x) split(data.frame(x), f = x[, "group"]))
             list.name <- names(Hazard.by.group[[1]])
             CIF.table <- list()

             for (jj in 1:length(list.name)){
                 Hazard.each.group  <- list()

                 for (kk in 1:K.cause){
                     Hazard.each.group[[kk]] <- as.data.frame(Hazard.by.group[[kk]][list.name[jj]])
                 }

                     Hazard.each.group <- lapply(Hazard.each.group, setNames,
                                                 nm = c("events.time", "Lambda_k", "h_k", "group"))
                     Hazard.each.group <- Reduce(function(x, y) merge(x, y, by="events.time", all=TRUE), Hazard.each.group)
                     Hazard.each.group <- Hazard.each.group[,-grep("group", colnames(Hazard.each.group))]
                     Hazard.each.group <- Impute.Lambda(Hazard.each.group)
                     Hazard.each.group <- Impute.h(Hazard.each.group)
                     colnames(Hazard.each.group) <- c("events.time", paste(rep(c("Lambda","h"), times = K.cause),
                                                      rep(1:K.cause, each = 2), sep=""),paste("delta", 1:K.cause, sep=""))
                     Survival <- exp(- apply(Hazard.each.group[, grep("Lambda", colnames(Hazard.each.group))], 1, sum))
                     Survival <- ifelse(is.na(Survival), 1, Survival)
                     h <- Hazard.each.group[, grep("h", colnames(Hazard.each.group))]
                     delta <- Hazard.each.group[, grep("delta", colnames(Hazard.each.group))]
                     CIF <- apply(Survival*h, 2, cumsum)
                     CIF.xi <- Survival*h
                     CIF.each.group <- data.frame(events.time = Hazard.each.group$events.time,  Survival, CIF, CIF.xi, delta)
                     colnames(CIF.each.group) <- c("events.time", "Survival", paste("CIF", 1:K.cause, sep=""),
                                         paste("CIF.xi", 1:K.cause, sep=""), paste("delta", 1:K.cause, sep=""))
                     CIF.table[[jj]] <- CIF.each.group
             }
          }
       return(CIF.table)
}

est.CIF <-
function(formulas, data, group, group.in.train, newdata, compute.CI,
                    alpha=0.05, transform="log-log", save){

                    Hazard.table <- model.fit <- event <- list()
                    for (kk in 1:length(formulas)){
                         mf <- model.frame(formula = formulas[[kk]], data = data)
                         x <- model.matrix(formulas[[kk]], data = data)
                         x <- x[, -1]
                         y <- model.response(mf)
                         event[[kk]] <- y[,2]
                         est <- tryCatch(coxph(formulas[[kk]], data=data),  error=function(e) e)

                         if(is(est, "simpleError")) {
                          break
                        } else{
                          est$call <- match.call()
                          est$formula <- formulas[[kk]]
                          est$coefficients <- ifelse(is.na(est$coefficients), 0 ,est$coefficients)
                          model.fit[[kk]] <- est
                          Hazard.table[[kk]] <- Lambda_k(est, x, y, group = group,
                                                         data=data, newdata = newdata,
                                                         group.in.train = group.in.train)
                        }
                    }
                    event <- Reduce("+", event)
                    cat("Estimate cumulative hazards for each type of failure.\n")

                    if (length(model.fit)!=length(formulas)){
                       cat("Cox proportional hazards model does not converge for at least one type of failure\n")
                       break
                    } else{
                       CIFest <- CIF_k(Hazard.table = Hazard.table, group = group)
                    }
                    cat("Estimate cumulative incidence for each type of failure.\n")

                      if(is.null(group)){
                         CIF.output <- temp <- list()
                         for(kk in 1:length(formulas)){
                             CIF <- CIFest[,paste("CIF",kk, sep="")]
                             delta.kk <- CIFest[, paste("delta", kk, sep="")]
                             temp$model.fit <- model.fit[[kk]]
                             temp$call <- formulas[[kk]]
                             temp$Estimate <- data.frame(Events.Time= CIFest$events.time,
                                                         Overall.Survival = CIFest$Survival,
                                                         Cumulative.Incidence = CIF,
                                                         delta = delta.kk)
                             CIF.output[[kk]] <- temp
                         }
                      }

                      if(is.null(group)==F){
                         CIF.output <- temp <- temp2 <- list()
                         for (kk in 1:length(formulas)){
                             for (jj in 1:nlevels(newdata[,group])){
                                 CIF <- CIFest[[jj]][,paste("CIF",kk, sep="")]
                                 delta.kk <- CIFest[[jj]][, paste("delta", kk, sep="")]
                                 temp$model.fit <- model.fit[[kk]]
                                 temp$call <- formulas[[kk]]
                                 temp$group <- levels(newdata[,group])[jj]
                                 temp$Estimate <- data.frame(Events.Time= CIFest[[jj]]$events.time,
                                                         Overall.Survival = CIFest[[jj]]$Survival,
                                                         Cumulative.Incidence = CIF,
                                                         delta = delta.kk)
                               temp2[[jj]] <- temp
                             }
                           CIF.output[[kk]] <- temp2
                         }
                      }
                    class(CIF.output) <- "CIF"

                   # compute (1-alpha)% pointwise confidence interval #
                   if (transform =="log-log"){
                       g <- function(x){
                            log(-log(x))
                            }

                       g.inv <- function(x){
                                exp(-exp(x))
                                }

                       g.prime <- function(x){
                                  1/(x*(-log(x)))
                                  }
                       }


                   if (compute.CI==T){
                       cat("Compute (1-alpha)% pointwise confidence interval.\n")
                       CIF.var <- RawVar.CIF(formulas, CIFest, data, newdata, group, event,save, group.in.train)
                       z.alpha <- qnorm(alpha/2, lower.tail=F)
                       n <- nrow(data)

                       if(is.null(group)){
                          CIF.output <- temp <- list()

                          for(kk in 1:length(formulas)){
                             CIF <- CIFest[,paste("CIF",kk, sep="")]
                             lb <- g.inv(g(CIF) + n^{-1/2}*g.prime(CIF)*z.alpha*(CIF.var[[kk]])^(1/2))
                             ub <- g.inv(g(CIF) - n^{-1/2}*g.prime(CIF)*z.alpha*(CIF.var[[kk]])^(1/2))
                             delta.kk <- CIFest[, paste("delta", kk, sep="")]
                             temp$model.fit <- model.fit[[kk]]
                             temp$call <- formulas[[kk]]
                             temp$Estimate <- data.frame(Events.Time = CIFest$events.time,
                                                         Overall.Survival = CIFest$Survival,
                                                         Cumulative.Incidence = CIF,
                                                         delta = delta.kk,
                                                         Upper.Bound=ub, Lower.Bound=lb)
                             CIF.output[[kk]] <- temp
                          }
                       }

                       if(is.null(group) == F){
                          CIF.est <- temp <- list()

                          for(kk in 1:length(formulas)){
                              CIF.var.group <- list()

                              for (jj in 1: nlevels(newdata[,group])){
                                  CIF <- CIFest[[jj]][,paste("CIF",kk, sep="")]
                                  lb <- g.inv(g(CIF) + n^{-1/2}*g.prime(CIF)*z.alpha*(CIF.var[[kk]][[jj]])^(1/2))
                                  ub <- g.inv(g(CIF) - n^{-1/2}*g.prime(CIF)*z.alpha*(CIF.var[[kk]][[jj]])^(1/2))
                                  delta.kk <- CIFest[[jj]][, paste("delta", kk, sep="")]
                                  temp$model.fit <- model.fit[[kk]]
                                  temp$call <- formulas[[kk]]
                                  temp$group <- levels(newdata[,group])[jj]
                                  temp$Estimate <- data.frame(Events.Time = CIFest[[jj]]$events.time,
                                                              Overall.Surival = CIFest[[jj]]$Survival,
                                                              Cumulative.Incidence = CIF,
                                                              delta = delta.kk,
                                                              Upper.Bound=ub,
                                                              Lower.Bound=lb)
                                  CIF.var.group[[jj]] <- temp
                              }
                          CIF.output[[kk]] <- CIF.var.group
                          }
                       }
                   class(CIF.output) <- "CIF"
                   }
                  return(CIF.output)

}

#' @method summary CIF
summary.CIF <-
function(object, group, ...){

               if(is.null(group)){
                 for (kk in 1:length(object)){
                      print(object[[kk]]$call)
                      print(head(object[[kk]]$Estimate))
                      cat("......\n")
                      print(tail(object[[kk]]$Estimate))
                      cat("\n\n\n")
                 }
               }

               if(is.null(group)==F){
                 for (kk in 1:length(object)){
                   for(jj in 1:length(object[[kk]])){
                      print(object[[kk]][[jj]]$call)
                      cat(paste(object[[kk]][[jj]]$group,"\n", sep=""))
                      print(head(object[[kk]][[jj]]$Estimate))
                      cat("......\n")
                      print(tail(object[[kk]][[jj]]$Estimate))
                      cat("\n\n\n")
                   }
                 }
               }
}

\name{CIF_k}
\alias{CIF_k}
\title{
The k^th cumulative incidence function.
}
\description{
This function aggregates the hazards table for all type of failures and computes the point estimator of the cumulative incidence function.
}
\usage{
CIF_k(Hazard.table, group)
}
\arguments{
  \item{Hazard.table}{
   An output from \code{Lambda_k(est, x, y, group,...)}.
}
  \item{group}{
The name of the group covariates (if any). If specified, the cumulative incidence function will be computed for each group seperately.
}
}
\details{
This function estimates the cumulative incidence function for the k^{th} type of failure based on the observed data. When group is specified, the cumulative hazards for the k^{th} type of failure will be computed for each group seperately.
}
\value{
It returns a data frame contains time of events, cumulative incidence, cumulative hazards for each type of failure, and group indicators (if any).
}
\keyword{Cumulative incidence function}

\name{Baseline_Lambda_k}
\alias{Baseline_Lambda_k}
\title{
Baseline cumulative hazards}
\description{
Estimate the baseline cumulative hazards for the k^th type of failure.
}
\usage{
Baseline_Lambda_k(est, x, y)
}
\arguments{
  \item{est}{
The model fitting details from the k^th cause-specific hazards model.
}
  \item{x}{
The design matrix associated with the k^th type of failure, of dimension n observations and p_k covariates.
}
  \item{y}{
The survival response associated with the k^th type of failure.
}
}
\details{
This function estimates the baseline cumulative hazards for the k^th type of failure. The estimated baseline cumulative hazard is a Breslow type estimator.
}
\references{
Breslow, Norman E. "Analysis of survival data under the proportional hazards model." International Statistical Review/Revue Internationale de Statistique (1975): 45-57.
}
\keyword{Baseline cumulative hazards }

\name{summary.CIF}
\alias{summary.CIF}
\title{
Summary for the cumulative incidence function and the pointwise confidence interval.
}
\description{
Summarize the cumulative incidence function and lower and upper pointwise confidence interval (if avaiable ) for each group and each type of failure from the \code{CIF} class.
}
\usage{
\method{summary}{CIF}(object, group, ...)
}

\arguments{
  \item{object}{
The \code{CIF} object generated by \code{est.CIF}.
}
\item{group}{The name of the group covariates (if any).
}
\item{...}{other arguments
}
}

\details{
For each group and each type of failure, this function returns the cumulative incidence function and lower and upper pointwise confidence interval (if avaiable ) for the top 5 and bottom 5 observations.
}


\keyword{summary}

\name{Lambda_k}
\alias{Lambda_k}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
The cumulative hazards for the k^th type of failure.
}
\description{
Estimate the cumulative hazards for the k^th type of failure.
}
\usage{
Lambda_k(est, x, y, group, data, newdata, group.in.train)
}

\arguments{
  \item{est}{
The model fitting details from the k^th cause-specific hazards model.
}
  \item{x}{
The design matrix associated with the k^th  type of failure, of dimension n observation * p_k covariates.
}
  \item{y}{
The survival response associated with the k^th type of failure.
}
  \item{group}{
The name of the group covariates (if any). If specified, the cumulative hazards will be estimated for each group seperately. Default is \code{group=NULL}.
}
  \item{data}{
A data frame with n observations and p number of covariates.
}
  \item{newdata}{
A data frame or a matrix used for prediction. If not specified, the original data will be used instead.
}
  \item{group.in.train}{
This argument is valid only when the group argument is specified. If group is presented in both data and newdata, use \code{group.in.train=T}. If group is presented in only newdata but not data, use \code{group.in.train=F}.
}
}
\details{
This function estimates the cumulative hazards for the k^th type of failure based on the observed data. It also introduces a flexible structure to predict the cumulative hazards for the k^th type of failure for a given new observation. When newdata has more than 2 observations, the mean values of the covariates will be used for prediction. When group is specified, the cumulative hazards for the k^th type of failure will be computed for each group seperately.
}
\value{
It returns a data frame contains time of events, cumulative hazards for each type of failure, and group indicators (if any).
}

\keyword{Cumulative hazards}

\name{Psi_par}
\alias{Psi_par}
\title{
\deqn{\psi}
}
\description{
This function computes psi_kl(t;z_{0}).
}
\usage{
Psi_par(formulas, kk, ll, CIFest, data, newdata, group, event, save, group.in.train)
}

\arguments{
  \item{formulas}{
A list of length K contains formula objects, where K is the number of types of failures. Each element is a formula object, with the response on the left of a ~ operator, and the terms on the right. The response must be a survival object as returned by the Surv function.
}
  \item{kk}{
The k^th type of failure.
}
  \item{ll}{
The l^th type of failure.
}
  \item{CIFest}{
The point estimator of the cumulative incidence function.
}
\item{data}{
A data frame with n observations and p number of covariates.
}
  \item{newdata}{
A data frame or a matrix used for prediction. If not specified, the original data will be used instead.
}
 \item{group}{
The name of the group covariates (if any). If specified, the cumulative hazards will be estimated for each group seperately. Default is \code{group=NULL}.
}
  \item{event}{
This is an internal binary indicator to specify if any type of failure occurs at a given time.
}

  \item{save}{
An option to save the computed S0 and S1. It is highly recommended for large-scale dataset to improve the computational efficiency. Default is \code{save=FALSE}.
}
  \item{group.in.train}{
This argument is valid only when the group argument is specified. If group is presented in both data and newdata, use \code{group.in.train=T}; If group is presented in only newdata but not data, use \code{group.in.train=F}.
}
}

\references{
Cheng, S. C., Jason P. Fine, and L. J. Wei. "Prediction of cumulative incidence function under the proportional hazards model." Biometrics (1998): 219-228.
}

\details{
This function computes \deqn{\hat{\psi}_{kl}(t; z_{0}) = \frac{1}{n}\sum_{i=1}^{n}(\hat{F}_{k}(t; z_{0}) - \hat{F}_{k}(\tilde{T}_{i}; z_{0}))(z_{0}- \bar{Z}(\hat{\beta}_{l}, \tilde{T_{i}}))\frac{\exp(\hat{\beta}_{l}^{T}z_{0})\delta_{li}I(\tilde{T}_{i} \le t)}{S^{(0)}(\hat{\beta}_{l}, \tilde{T}_{i})}}
}

\name{Impute.Lambda}
\alias{Impute.Lambda}
\description{Impute.Lambda}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
internal
}
\keyword{internal}% use one of  RShowDoc("KEYWORDS")

\name{CompetingRisk-package}
\alias{CompetingRisk-package}
\alias{CompetingRisk}
\docType{package}
\title{
The Semi-Parametric Cumulative Incidence Function
}
\description{
Computing the point estimator and pointwise confidence interval of the cumulative incidence function from the cause-specific hazards model. This package contains generic methods (\code{plot},\code{summary}) that can be invoked for an object fitted using \code{est.CIF()}.
}

\details{
%\packageDescription{CompetingRisk}
\packageDESCRIPTION{CompetingRisk}
%~~ functions ~~
%Package{CompetingRisk}
%Type: Package\\
%Version: 1.0\\
%Date: 2017-02-25\\
%License: GPL-3\\
}
\author{
Jiayi Hou and Ronghui Xu

Maintainer: Jiayi Hou <jhou12@icloud.com>
}
\references{
Cheng, S. C., Jason P. Fine, and L. J. Wei. "Prediction of cumulative incidence function under the proportional hazards model." Biometrics (1998): 219-228. DOI: 10.2307/2534009 
}

\keyword{Competing Risk}

\examples{
\dontrun{
data("train.data")
data("test.data2")

#1.Example: no group in training and test #
formulas <- list(as.formula("Surv(dtime, prostate) ~ AG + WT + PF + HX +HG + SZ + SG + RX"),
                 as.formula("Surv(dtime, cardio) ~ AG + WT + PF + HX +HG + SZ + SG + RX"),
                 as.formula("Surv(dtime, Other_causes) ~ AG + WT + PF + HX +HG + SZ + SG + RX"))
CIF.output <- est.CIF(formulas, data = train.data, newdata = test.data2,
                  group=NULL, compute.CI=T,save=F)
plot(CIF.output)
}
}

\name{Compute_Omega}
\alias{Compute_Omega}
\title{
Omega_k
}
\description{
This function computes Omega_k.
}
\usage{
Compute_Omega(est, x, y, kk, event, group, save, group.in.train)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{est}{
The model fitting details from the k^th cause-specific hazards model.
}
  \item{x}{
The design matrix associated with the k^th type of failure, of dimension n observations * p_k covariates.
}
  \item{y}{
The survival response associated with the k^th type of failure.
}
  \item{kk}{
The k^th type of failure.
}
  \item{event}{
This is an internal binary indicator to specify if any type of failure occurs at a given time.
}
  \item{group}{
The name of the group covariates (if any). If specified, the cumulative hazards will be estimated for each group seperately. Default is \code{group=NULL}.
}
  \item{save}{
An option to save the computed S0 and S1. It is highly recommended for large-scale dataset to improve the computational efficiency. Default is \code{save=FALSE}.
}
  \item{group.in.train}{
This argument is valid only when the group argument is specified. If group is presented in both data and newdata, use \code{group.in.train=T}; If group is presented in only newdata but not data, use \code{group.in.train=F}.
}
}
\references{
Cheng, S. C., Jason P. Fine, and L. J. Wei. "Prediction of cumulative incidence function under the proportional hazards model." Biometrics (1998): 219-228.
}

\details{
This function computes \deqn{\hat{\Omega}_{k} = \frac{1}{n}\sum_{i=1}^{n}\bigg(\frac{S^{(2)}(\hat{\beta}_{k}, \tilde{T}_{i})} {S^{(0)}(\hat{\beta}_{k}, \tilde{T}_{i})} - \bar{Z}(\hat{\beta}_{k}, \tilde{T_{i}})^{\otimes 2} \bigg)\delta_{ki}}
}

\name{Varphi_par}
\alias{Varphi_par}
\title{
\deqn{\varphi}
}
\description{
This function computes varphi_k(t;z_{0}).
}
\usage{
Varphi_par(est, x, y, kk, CIFest, data, newdata, group, event, save, group.in.train)
}
\arguments{
  \item{est}{
The model fitting details from the k^th cause-specific hazards model.
}
  \item{x}{
The design matrix associated with the k^th type of failure, of dimension n observations * p_k covariates.
}
  \item{y}{
The survival response associated with the k^th type of failure.
}
  \item{kk}{
The k^th type of failure.
}
  \item{CIFest}{
(Internal) The point estimator of the cumulative incidence function.
  }
\item{data}{
A data frame with n observations and p number of covariates.
}
  \item{newdata}{
A data frame or a matrix used for prediction. If not specified, the original data will be used instead.
}
  \item{group}{
The name of the group covariates (if any). If specified, the cumulative hazards will be estimated for each group seperately. Default is \code{group=NULL}.
}

  \item{event}{
This is an internal binary indicator to specify if any type of failure occurs at a given time.
}

  \item{save}{
An option to save the computed S0 and S1. It is highly recommended for large-scale dataset to improve the computational efficiency. Default is \code{save=FALSE}.
}
  \item{group.in.train}{
This argument is valid only when the group argument is specified. If group is presented in both data and newdata, use \code{group.in.train=T}. If group is presented in only newdata but not data, use \code{group.in.train=F}.
}
}

\references{
Cheng, S. C., Jason P. Fine, and L. J. Wei. "Prediction of cumulative incidence function under the proportional hazards model." Biometrics (1998): 219-228.
}

\details{
This function computes \deqn{\hat{\varphi}_{k}(t; z_{0}) = \frac{1}{n}\sum_{i=1}^{n}\hat{S}(\tilde{T}_{i}; z_{0})(z_{0}- \bar{Z}(\hat{\beta}_{k}, \tilde{T_{i}}))\frac{\exp(\hat{\beta}_{k}^{T}z_{0})\delta_{ji}I(\tilde{T}_{i} \le t)}{S^{(0)}(\hat{\beta}_{k}, \tilde{T}_{i})}}
}

\name{plot.CIF}
\alias{plot.CIF}
\title{
Plots the cumulative incidence function and the pointwise confidence interval (if any).
}
\description{
Plots the cumulative incidence function and lower and upper pointwise confidence interval (if avaiable ) for each group and each type of failure from the \code{CIF} class.
}
\usage{
\method{plot}{CIF}(x, type=NULL,...)
}

\arguments{
  \item{x}{
The \code{CIF} object generated by \code{est.CIF}.
}
  \item{type}{
The name of the group covariates (if any).
}
\item{...}{other arguments
}
}

\keyword{plot}

\name{train.data}
\alias{train.data}
\docType{data}
\title{
train data
}
\description{
This is a subset of data from a prostate cancer trial described in Byar and Green (1980).
}


\references{
Byar, D. P., and S. B. Green. "The choice of treatment for cancer patients based on covariate information." Bulletin du cancer 67.4 (1979): 477-490.
}

\keyword{datasets}

\name{est.CIF}
\alias{est.CIF}
\title{
 Cumulative incidence function.
}
\description{
This is the main function to obtain the point estimator and pointwise confidence interval for the cumulative incidence function.
}
\usage{
est.CIF(formulas, data, group, group.in.train, newdata,
        compute.CI, alpha = 0.05, transform = "log-log", save)
}
\arguments{
 \item{formulas}{
A list of length K contains formula objects, where K is the number of failures. Each element is a formula object, with the response on the left of a ~ operator, and the predictors on the right. The response must be a survival object as returned by the \code{Surv} function.
}
\item{data}{
A data frame with n observations and p number of covariates.
}
\item{group}{
The name of the group covariates (if any). If specified, the cumulative incidence function will be estimated for each group separately. Default is \code{group=NULL}.
}
\item{group.in.train}{
This argument is valid only when the group argument is specified. If group is presented in both data and newdata, use \code{group.in.train=T}; If group is presented in only newdata but not data, use \code{group.in.train=F}.
}
\item{newdata}{
A data frame or a matrix used for prediction. If not specified, the original data will be used instead.
}
\item{compute.CI}{
A logic operator for whether to compute the pointwise confidence interval. The default is \code{compute.CI=FALSE}.
}
\item{alpha}{
The significance level. The default is 0.05, which computes the \code{95\%} pointwise confidence interval.
}
\item{transform}{
An indicator if transformation is used for the confidence interval. Only log-log transformation is implemented currently.
}
\item{save}{
An option to save the computed S0 and S1. It is highly recommended for large-scale dataset to improve the computational efficiency. Default is \code{save=FALSE}.
}
}
\details{
This is the main function to compute the point estimator and pointwise confidence interval for the cumulative incidence function. We implemented a flexible function to allow prediction of cumulative incidence function under the cause-specific proportion hazards model in scenarios: 1) when group segmentation is not specified in training and test data; 2) when group segmentation is specified in both training and test data; 3) group segmentation is presented in the test data only; 4) the type of failure is associated with a different setts of covariates. To predict, user can input the new values of all covariates as a vector. If the \code{newdata} is specified, the mean of all observations with corresponding covariates will be used in the prediction. In addition, the generic functions such as \code{plot()}, \code{summary()} are available for the newly defined \code{CIF} class.
}
\value{
When \code{group=NULL}, \code{est.CIF} returns a list of length K. For each sublist, it contains:
\item{model.fit}{Details of model fit, such as parameter estimates, standard error, etc.}
\item{call}{The survival object used for a the k^th type of failure.}
\item{Estimate}{A data frame contains events.time, overall survival, cumulative incidence, upper and lower bounds (if \code{compute.CI = TRUE}).}
When \code{group} is specified, \code{est.CIF} returns a list of length that equals to the number of levels in \code{group} . For each sublist, it contains a list of length K.
}

\references{
Cheng, S. C., Jason P. Fine, and L. J. Wei. "Prediction of cumulative incidence function under the proportional hazards model." Biometrics (1998): 219-228.
}
\examples{
\dontrun{
data("train.data")
data("test.data2")

#1.Example: no group in training and test #
formulas <- list(as.formula("Surv(dtime, prostate) ~ AG + WT + PF + HX +HG + SZ + SG + RX"),
                 as.formula("Surv(dtime, cardio) ~ AG + WT + PF + HX +HG + SZ + SG + RX"),
                 as.formula("Surv(dtime, Other_causes) ~ AG + WT + PF + HX +HG + SZ + SG + RX"))
CIF.output <- est.CIF(formulas, data = train.data, newdata = test.data2,
                  group=NULL, compute.CI=T,save=F)
plot(CIF.output)

#2. Example: group in training data and test data #
formulas <- list(as.formula("Surv(dtime, prostate) ~ AG + WT + PF + HX +HG + SZ + SG + RX"),
                 as.formula("Surv(dtime, cardio) ~ AG + WT + PF + HX +HG + SZ + SG + RX"),
                 as.formula("Surv(dtime, Other_causes) ~ AG + WT + PF + HX +HG + SZ + SG + RX"))
CIF.output <- est.CIF(formulas, data=train.data, group="RX", group.in.train=T,
                      newdata=test.data2, compute.CI=T, alpha=0.05, transform="log-log", save=F)
plot(CIF.output, group="RX")

#3. Example: group not in training data and but in test data #
formulas <- list(as.formula("Surv(dtime, prostate) ~ AG + WT + PF + HX +HG + SZ + SG"),
                 as.formula("Surv(dtime, cardio) ~ AG + WT + PF + HX +HG + SZ + SG "),
                 as.formula("Surv(dtime, Other_causes) ~ AG + WT + PF + HX +HG + SZ + SG"))
CIF.output <- est.CIF(formulas, data=train.data, group="RX", group.in.train=F, newdata=test.data2,
                      compute.CI=T, alpha=0.05, transform="log-log", save=F)
plot(CIF.output, group="RX")


#4. Example: 1)group not in training data and but in test data
#            2)different risk factors associated with cause of failure #
formulas <- list(as.formula("Surv(dtime, prostate) ~ AG + WT + PF + HX +HG"),
                 as.formula("Surv(dtime, cardio) ~  PF + HX +HG "),
                 as.formula("Surv(dtime, Other_causes) ~ AG + WT + PF + HX +HG + SZ"))
CIF.output <- est.CIF(formulas, data=train.data, group="RX", group.in.train=F,
                      newdata=test.data2,compute.CI=T, alpha=0.05, transform="log-log", save=T)
plot(CIF.output, group="RX")

#5. Example: different risk factors associated with cause of failure #
formulas <- list(as.formula("Surv(dtime, prostate) ~ AG + WT + PF + HX +HG"),
                 as.formula("Surv(dtime, cardio) ~  PF + HX +HG + SZ"),
                 as.formula("Surv(dtime, Other_causes) ~ AG + WT + PF + HX +HG + SZ + SG"))
CIF.output <- est.CIF(formulas, data=train.data, group=NULL, group.in.train=F, newdata=test.data2,
                      compute.CI=T, alpha=0.05, transform="log-log", save=F)
plot(CIF.output)
}
}

\name{Compute_S01}
\alias{Compute_S01}
\title{
S0 and S1
}
\description{
This function computes S0 and S1 in counting process.
}
\usage{
Compute_S01(est, x, y, kk, event, group, save, group.in.train)
}

\arguments{
  \item{est}{
The model fitting details from the k^th cause-specific hazards model.
}
  \item{x}{
The design matrix associated with the k^th type of failure, of dimension n observations * p_k covariates.
}
  \item{y}{
The survival response associated with the k^th type of failure.
}
  \item{kk}{
The k^th type of failure.
}
  \item{event}{
This is an internal binary indicator to specify if any type of failure occurs at a given time.
}
  \item{group}{
The name of the group covariates (if any). If specified, the cumulative hazards will be estimated for each group seperately. Default is \code{group=NULL}.
}
  \item{save}{
An option to save the computed S0 and S1. It is highly recommended for large-scale dataset to improve the computational efficiency. Default is \code{save=FALSE}.
}
  \item{group.in.train}{
This argument is valid only when the group argument is specified. If group is presented in both data and newdata, use \code{group.in.train=T}. If group is presented in only newdata but not data, use \code{group.in.train=F}.
}
}
\references{
Andersen, Per Kragh, et al. Statistical models based on counting processes. Springer Science & Business Media, 2012.
}

\details{
This function computes \deqn{S^{(0,1)}(\hat{\beta}, t; z_{0}) = \frac{1}{n}\sum_{i^{\prime}=1}^{n}I(\tilde{T}_{i^{\prime}} \ge t) \exp(\hat{\beta}^{T}Z_{j})Z_{j}^{\otimes 0,1}}
}

\name{RawVar.CIF}
\alias{RawVar.CIF}
\title{
Variance of cumulative incidence function
}
\description{
This function computes the estimate of variance of the cumulative incidence function.
}
\usage{
RawVar.CIF(formulas, CIFest, data, newdata, group, event, save, group.in.train)
}
\arguments{
 \item{formulas}{
A list of length K contains formula objects, where K is the number of failures. Each element is a formula object, with the response on the left of a ~ operator, and the predictors on the right. The response must be a survival object as returned by the \code{Surv} function.
}
\item{CIFest}{
The point estimator of the cumulative incidence function.
}
\item{data}{
A data frame with n observations and p number of covariates.
}
\item{newdata}{
A data frame or a matrix used for prediction. If not specified, the original data will be used instead.
}
\item{group}{
The name of the group covariates (if any). If specified, the cumulative hazards will be estimated for each group seperately. Default is \code{group=NULL}.
}
\item{event}{
This is an internal binary indicator to specify if any type of failure occurs at a given time.
}
\item{save}{
An option to save the computed S0 and S1. It is highly recommended for large-scale dataset to improve the computational efficiency. Default is \code{save=FALSE}.
}
\item{group.in.train}{
This argument is valid only when the group argument is specified. If group is presented in both data and newdata, use \code{group.in.train=T}; If group is presented in only newdata but not data, use \code{group.in.train=F}.
}
}

\references{
Cheng, S. C., Jason P. Fine, and L. J. Wei. "Prediction of cumulative incidence function under the proportional hazards model." Biometrics (1998): 219-228.
}

\details{
This function computes: \deqn{\hat{\xi}(s,t;z_{0})=\frac{1}{n} \sum_{i=1}^{n}[\hat{S}(\tilde{T}_{i}; z_{0}) - (\hat{F}_{j}(t;z_{0}) -\hat{F}_{k}(\tilde{T}_{i};z_{0}) )]^2\frac{\exp(2\hat{\beta}_{j}^{T}z_{0})\delta_{ji}I(\tilde{T}_{i} \le t)}{(S^{(0)}(\hat{\beta}_{j}, \tilde{T}_{i}))^{2}}}

}

\name{Impute.h}
\alias{Impute.h}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
internal
}
\description{
impute.h
}
\usage{
Impute.h(x)
}
\keyword{internal}% use one of  RShowDoc("KEYWORDS")
